AppDomain.FirstChanceException 이벤트

정의

애플리케이션 도메인에서 런타임이 예외 처리기에 대한 호출 스택을 검색하기 전에 관리 코드에서 예외가 throw될 경우 발생합니다.Occurs when an exception is thrown in managed code, before the runtime searches the call stack for an exception handler in the application domain.

public:
 event EventHandler<System::Runtime::ExceptionServices::FirstChanceExceptionEventArgs ^> ^ FirstChanceException;
[add: System.Security.SecurityCritical]
[remove: System.Security.SecurityCritical]
public event EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> FirstChanceException;
member this.FirstChanceException : EventHandler<System.Runtime.ExceptionServices.FirstChanceExceptionEventArgs> 
Public Custom Event FirstChanceException As EventHandler(Of FirstChanceExceptionEventArgs) 
특성

예제

다음 예제에서는 일련의 명명 된 애플리케이션 도메인을 만듭니다 AD0 를 통해 AD3를 사용 하 여를 Worker 각 애플리케이션 도메인의 개체입니다.The following example creates a series of application domains named AD0 through AD3, with a Worker object in each application domain. Worker 개체에 대 한 참조에는 Worker 제외 하 고 다음 애플리케이션 도메인의 개체는 Worker 마지막 애플리케이션 도메인에서.Each Worker object has a reference to the Worker object in the next application domain, except for the Worker in the last application domain. 합니다 FirstChanceException 를 제외한 모든 애플리케이션 도메인에서 이벤트를 처리 AD1합니다.The FirstChanceException event is handled in all application domains except AD1.

참고

여러 애플리케이션 도메인에서 첫째 예외 알림을 보여 주는이 예제 외에도 간단한 사용 사례를 찾을 수 있습니다 방법: 첫째 예외 알림 받기합니다.In addition to this example, which demonstrates first-chance exception notifications in multiple application domains, you can find simple use cases in How to: Receive First-Chance Exception Notifications.

애플리케이션 도메인을 만든 경우 기본 애플리케이션 도메인 호출을 TestException 메서드 첫 번째 애플리케이션 도메인에 대 한 합니다.When the application domains have been created, the default application domain calls the TestException method for the first application domain. Worker 호출 개체의 TestException 마지막까지 다음 애플리케이션 도메인에 대 한 메서드 Worker 처리 되거나 처리 되지 않은 예외를 throw 합니다.Each Worker object calls the TestException method for the next application domain, until the last Worker throws an exception that is either handled or unhandled. 따라서 현재 스레드는 모든 애플리케이션 도메인을 통해 전달 및 TestException 스택의 각 애플리케이션 도메인에 추가 됩니다.Thus, the current thread passes through all the application domains, and TestException is added to the stack in each application domain.

때 마지막 Worker 개체에서 예외를 처리 합니다 FirstChanceException 마지막 애플리케이션 도메인에만 이벤트가 발생 합니다.When the last Worker object handles the exception, the FirstChanceException event is raised only in the last application domain. 다른 애플리케이션 도메인 이벤트가 발생 하므로 예외를 처리 하는 받은 적입니다.The other application domains never get a chance to handle the exception, so the event is not raised.

때 마지막 Worker 개체에서 예외를 처리 하지 않습니다는 FirstChanceException 이벤트는 이벤트 처리기가 각 애플리케이션 도메인에서 발생 합니다.When the last Worker object does not handle the exception, the FirstChanceException event is raised in each application domain that has an event handler. 각 이벤트 처리기가 끝나면 스택 해제 예외는 기본 애플리케이션 도메인에서 발견 될 때까지 계속 합니다.After each event handler has finished, the stack continues to unwind until the exception is caught by the default application domain.

참고

변경 이벤트가 더 가까운 곳으로 스택 표시 증가 하는 방법 및 기본 애플리케이션 도메인에 가까울수록 서로 볼 e.Exception.Messagee.ExceptionFirstChanceHandler 이벤트 처리기입니다.To see how the stack display grows as the event is raised closer and closer to the default application domain, change e.Exception.Message to e.Exception in the FirstChanceHandler event handlers. TestException 라고 애플리케이션 도메인 경계를 가로질러 두 번 나타납니다: 프록시에 한 번씩 및 스텁에 대 한 한 번입니다.Notice that when TestException is called across application domain boundaries, it appears twice: once for the proxy and once for the stub.

using System;
using System.Reflection;
using System.Runtime.ExceptionServices;

class Example
{
    static void Main()
    {
        AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;

        // Create a set of application domains, with a Worker object in each one.
        // Each Worker object creates the next application domain.
        AppDomain ad = AppDomain.CreateDomain("AD0");
        Worker w = (Worker) ad.CreateInstanceAndUnwrap(
                                typeof(Worker).Assembly.FullName, "Worker");
        w.Initialize(0, 3);

        Console.WriteLine("\r\nThe last application domain throws an exception and catches it:");
        Console.WriteLine();
        w.TestException(true);

        try
        {
            Console.WriteLine(
                "\r\nThe last application domain throws an exception and does not catch it:");
            Console.WriteLine();
            w.TestException(false);
        }
        catch (ArgumentException ex)
        {
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

public class Worker : MarshalByRefObject
{
    private AppDomain ad = null;
    private Worker w = null;

    public void Initialize(int count, int max)
    {
        // Handle the FirstChanceException event in all application domains except
        // AD1.
        if (count != 1)
        {
            AppDomain.CurrentDomain.FirstChanceException += FirstChanceHandler;
        }

        // Create another application domain, until the maximum is reached.
        // Field w remains null in the last application domain, as a signal
        // to TestException(). 
        if (count < max)
        {
            int next = count + 1;
            ad = AppDomain.CreateDomain("AD" + next);
            w = (Worker) ad.CreateInstanceAndUnwrap(
                             typeof(Worker).Assembly.FullName, "Worker");
            w.Initialize(next, max);
        }
    }

    public void TestException(bool handled)
    {
        // As long as there is another application domain, call TestException() on
        // its Worker object. When the last application domain is reached, throw a
        // handled or unhandled exception.
        if (w != null)
        {
            w.TestException(handled);
        }
        else if (handled)
        {
            try
            {
                throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
            }
            catch (ArgumentException ex)
            {
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message);
            }
        }
        else
        {
            throw new ArgumentException("Thrown in " + AppDomain.CurrentDomain.FriendlyName);
        }
    }

    static void FirstChanceHandler(object source, FirstChanceExceptionEventArgs e)
    {
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message);
    }
}

/* This example produces output similar to the following:

The last application domain throws an exception and catches it:

FirstChanceException event raised in AD3: Thrown in AD3
ArgumentException caught in AD3: Thrown in AD3

The last application domain throws an exception and does not catch it:

FirstChanceException event raised in AD3: Thrown in AD3
FirstChanceException event raised in AD2: Thrown in AD3
FirstChanceException event raised in AD0: Thrown in AD3
FirstChanceException event raised in Example.exe: Thrown in AD3
ArgumentException caught in Example.exe: Thrown in AD3
 */
Imports System.Reflection
Imports System.Runtime.ExceptionServices

Class Example

    Shared Sub Main()
    
        AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        ' Create a set of application domains, with a Worker object in each one.
        ' Each Worker object creates the next application domain.
        Dim ad As AppDomain = AppDomain.CreateDomain("AD0")
        Dim w As Worker = CType(ad.CreateInstanceAndUnwrap(
                                GetType(Worker).Assembly.FullName, "Worker"),
                                Worker)
        w.Initialize(0, 3)

        Console.WriteLine(vbCrLf & "The last application domain throws an exception and catches it:")
        Console.WriteLine()
        w.TestException(true)

        Try
            Console.WriteLine(vbCrLf & 
                "The last application domain throws an exception and does not catch it:")
            Console.WriteLine()
            w.TestException(false) 

        Catch ex As ArgumentException
        
            Console.WriteLine("ArgumentException caught in {0}: {1}", 
                AppDomain.CurrentDomain.FriendlyName, ex.Message)
        End Try
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

Public Class Worker
    Inherits MarshalByRefObject

    Private ad As AppDomain = Nothing
    Private w As Worker = Nothing

    Public Sub Initialize(ByVal count As Integer, ByVal max As Integer)
    
        ' Handle the FirstChanceException event in all application domains except
        ' AD1.
        If count <> 1
        
            AddHandler AppDomain.CurrentDomain.FirstChanceException, AddressOf FirstChanceHandler

        End If

        ' Create another application domain, until the maximum is reached.
        ' Field w remains Nothing in the last application domain, as a signal 
        ' to TestException(). 
        If count < max
            Dim nextAD As Integer = count + 1
            ad = AppDomain.CreateDomain("AD" & nextAD)
            w = CType(ad.CreateInstanceAndUnwrap(
                      GetType(Worker).Assembly.FullName, "Worker"),
                      Worker)
            w.Initialize(nextAD, max)
        End If
    End Sub

    Public Sub TestException(ByVal handled As Boolean)
    
        ' As long as there is another application domain, call TestException() on
        ' its Worker object. When the last application domain is reached, throw a
        ' handled or unhandled exception.
        If w IsNot Nothing
        
            w.TestException(handled)

        Else If handled
        
            Try
                Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)

            Catch ex As ArgumentException
            
                Console.WriteLine("ArgumentException caught in {0}: {1}", 
                    AppDomain.CurrentDomain.FriendlyName, ex.Message)
            End Try
        Else
        
            Throw New ArgumentException("Thrown in " & AppDomain.CurrentDomain.FriendlyName)
        End If
    End Sub

    Shared Sub FirstChanceHandler(ByVal source As Object, 
                                  ByVal e As FirstChanceExceptionEventArgs)
    
        Console.WriteLine("FirstChanceException event raised in {0}: {1}",
            AppDomain.CurrentDomain.FriendlyName, e.Exception.Message)
    End Sub
End Class

' This example produces output similar to the following:
'
'The last application domain throws an exception and catches it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'ArgumentException caught in AD3: Thrown in AD3
'
'The last application domain throws an exception and does not catch it:
'
'FirstChanceException event raised in AD3: Thrown in AD3
'FirstChanceException event raised in AD2: Thrown in AD3
'FirstChanceException event raised in AD0: Thrown in AD3
'FirstChanceException event raised in Example.exe: Thrown in AD3
'ArgumentException caught in Example.exe: Thrown in AD3

설명

이 이벤트는 알림만 있습니다.This event is only a notification. 이 이벤트를 처리 해도 예외를 처리 하거나 다른 예외 처리에 영향을 주지 않습니다.Handling this event does not handle the exception or affect subsequent exception handling in any way. 이벤트가 발생 하 고 이벤트 처리기가 호출 되 면 CLR (공용 언어 런타임)이 예외에 대 한 처리기를 검색 하기 시작 합니다.After the event has been raised and event handlers have been invoked, the common language runtime (CLR) begins to search for a handler for the exception. FirstChanceException 관리 되는 모든 예외를 검사 하는 첫 번째 기회를 사용 하 여 애플리케이션 도메인을 제공 합니다.FirstChanceException provides the application domain with a first chance to examine any managed exception.

애플리케이션 도메인 별로 이벤트를 처리할 수 있습니다.The event can be handled per application domain. 스레드 호출을 실행 하는 동안 여러 애플리케이션 도메인을 통해 전달, CLR 해당 애플리케이션 도메인의 일치 하는 예외 처리기 검색을 시작 하기 전에 이벤트 처리기를 등록 된 각 애플리케이션 도메인에서 이벤트가 발생 합니다.If a thread passes through multiple application domains while executing a call, the event is raised in each application domain that has registered an event handler, before the CLR begins searching for a matching exception handler in that application domain. 이벤트가 처리 된 후 해당 애플리케이션 도메인의 일치 하는 예외 처리기에 대 한 검색이 수행 됩니다.After the event has been handled, a search is made for a matching exception handler in that application domain. 미디어가 없는 경우 다음 애플리케이션 도메인에서 이벤트가 발생 합니다.If none is found, the event is raised in the next application domain.

FirstChanceException 이벤트에 대 한 이벤트 처리기에서 발생 하는 모든 예외를 처리 해야 합니다.You must handle all exceptions that occur in the event handler for the FirstChanceException event. 그렇지 않으면 FirstChanceException 재귀적으로 발생 합니다.Otherwise, FirstChanceException is raised recursively. 이 스택 오버플로 및 애플리케이션이 종료 될 수 있습니다.This could result in a stack overflow and termination of the application. 이 이벤트에 대 한 이벤트 처리기를 Cer (제약이 있는 실행 영역)로 구현 하는 것이 좋습니다 .이 이벤트는 메모리 부족 또는 스택 오버플로와 같이 예외 알림이 있는 동안 가상 컴퓨터에 영향을 주지 않도록 합니다. 처리 되 고 있습니다.We recommend that you implement event handlers for this event as constrained execution regions (CERs), to keep infrastructure-related exceptions such as out-of-memory or stack overflow from affecting the virtual machine while the exception notification is being processed.

이 이벤트는 이벤트 처리기가 보안에 중요 하 고 HandleProcessCorruptedStateExceptionsAttribute 특성이 있는 경우를 제외 하 고는 액세스 위반과 같은 프로세스 상태의 손상을 나타내는 예외에 대해 발생 하지 않습니다.This event is not raised for exceptions that indicate corruption of process state, such as access violations, unless the event handler is security-critical and has the HandleProcessCorruptedStateExceptionsAttribute attribute.

이 알림 이벤트를 처리 하는 동안 공용 언어 런타임에서는 스레드 중단을 일시 중단 합니다.The common language runtime suspends thread aborts while this notification event is being handled.

보안

SecurityCriticalAttribute
직접 실행 호출자에 대 한 완전 신뢰가 필요 합니다.Requires full trust for the immediate caller. 이 멤버는 부분적으로 신뢰할 수 있는 또는 투명 코드에서 사용할 수 없습니다.This member cannot be used by partially trusted or transparent code.

적용 대상

추가 정보